#include "tdgl.h"

// typedef
typedef void (*tdMemAlloc_Proc)( int nByte, int nPage );
typedef bool (*tdInitLibrary_Proc)( bool bFullScreen, int *nCtrl, HINSTANCE hInst );
typedef void (*tdEndLibrary_Proc)( void );
typedef void (*tdGetWndSize_Proc)( int *pWidth, int *pHeight );
typedef bool (*tdRun_Proc)( void );
typedef void (*tdCls_Proc)( DWORD color );
typedef void (*tdFlip_Proc)( void );
typedef int (*tdLoadModel_Proc)( char *fileName );
typedef int (*tdLoadAnime_Proc)( char *fileName );
typedef bool (*tdBindAnime_Proc)( int hModel, int hAnime, int nAnimeNo );
typedef void (*tdSetFreeze_Proc)( int hModel, bool bValid );
typedef void (*tdTransModel_Proc)( int hModel, MATRIX *mat, int nAnimeNo, float keyFrame, int nInterpolate, int nMorphNo );
typedef void (*tdRenderModel_Proc)( int hModel );
typedef void (*tdShadowMap_Proc)( VECTOR *vLightPos, int hFromModel, int hToModel, CAMERA *pCamera, BYTE Alpha );
typedef void (*tdTransMorph_Proc)( int hModel0, int nNo0, int hModel1, int nNo1, float param );
typedef int (*tdGetMaxAnime_Proc)( int hAnime );
typedef VECTOR (*tdGetModelCenter_Proc)( int hModel );
typedef float (*tdGetModelRadius_Proc)( int hModel );


typedef void (*tdSetWorldMatrix_Proc)( MATRIX *pMat );
typedef void (*tdSetViewMatrix_Proc)( MATRIX *pMat );
typedef void (*tdSetProjectionMatrix_Proc)( MATRIX *pMat );
typedef int (*tdLoadTex_Proc)( char *fileName );

typedef int (*tdLoadNormal_Proc)( char *fileName );
typedef void (*tdSetTexture_Proc)( DWORD dwStage, int hTex );
typedef void (*tdForceTex_Proc)( DWORD dwStage, int hTex, bool bForce );
typedef int (*tdCreateTex_Proc)( int width, int height, bool bRender );
typedef int (*tdCreateRGTex_Proc)( int width, int height, bool bRender );
typedef int (*tdCreateVolRGTex_Proc)( int width, int height, int depth );
typedef void (*tdSetRenderTex_Proc)( int hTex );
typedef void (*tdPrepCubeTex_Proc)( int hTex, int no, VECTOR *vPos );



typedef void (*tdShadeMode_Proc)( int nMode );
typedef int (*tdLoadTS_Proc)( char *fileName, char *funcName );
typedef int (*tdLoadVS_Proc)( char *fileName, char *funcName );
typedef int (*tdLoadPS_Proc)( char *fileName, char *funcName );
typedef void (*tdSetShader_Proc)( int hShader );
typedef void (*tdSetMat_Proc)( int hShader, char *name, MATRIX *mat );
typedef void (*tdSetFloats_Proc)( int hShader, char *name, float *values, int num );
typedef bool (*tdFillTex_Proc)( int hTex, int hShader );

typedef void (*tdDrawTex_Proc)( int hTex );
typedef void (*tdDrawTexPos_Proc)( int hTex, int x, int y );
typedef void (*tdDrawFontVL_Proc)( int x, int y, DWORD color, const char *format, va_list vl );
typedef void (*tdSetBlendMode_Proc)( int nMode, int nValue );
typedef int (*tdKeyIn_Proc)( int nMode );
typedef int (*tdGetJoy_Proc)( int nCtrlNo );
typedef void (*tdGetMousePos_Proc)( int *x, int *y );
typedef int (*tdLoadAudio_Proc)( char *fileName );
typedef void (*tdPlayAudio_Proc)( int hAudio );
typedef void (*tdStopAudio_Proc)( int hAudio );
typedef void (*tdSetAudioVolume_Proc)( int hAudio, float fVolume );
typedef bool (*tdIsPlayingAudio_Proc)( int hAudio );
typedef int (*tdGetFPS_Proc)( void );
typedef int (*tdCreateAttachedCap_Proc)( VECTOR *pV0, VECTOR *pV1, float fRadius,
						int hModel, char *szFrameName );
typedef void (*tdUpdateAttachedCap_Proc)( int hCap );
typedef CAPSULE* (*tdGetAttachedCap_Proc)( int hCap );
typedef void (*tdDrawCapsule_Proc)( CAPSULE *pCapsule, int nColor );
typedef int (*tdCreateOct_Proc)( int hModel, float fRate );
typedef bool (*tdIntersectOct_Proc)( int hOct, VECTOR *pV0, VECTOR *pV1, VECTOR *pVintersect );

// ֐|C^
//tdSetLogoTime_Proc tdSetLogoTime;
tdMemAlloc_Proc tdMemAlloc;
tdInitLibrary_Proc tdInitLibrary;
tdEndLibrary_Proc tdEndLibrary;
tdGetWndSize_Proc tdGetWndSize;
tdRun_Proc tdRun;
tdCls_Proc tdCls;
tdFlip_Proc tdFlip;
tdLoadModel_Proc tdLoadModel;
tdLoadAnime_Proc tdLoadAnime;
tdBindAnime_Proc tdBindAnime;
tdSetFreeze_Proc tdSetFreeze;
tdTransModel_Proc tdTransModel;
tdRenderModel_Proc tdRenderModel;
tdShadowMap_Proc tdShadowMap;
tdTransMorph_Proc tdTransMorph;
tdGetMaxAnime_Proc tdGetMaxAnime;
tdGetModelCenter_Proc tdGetModelCenter;
tdGetModelRadius_Proc tdGetModelRadius;


tdSetWorldMatrix_Proc tdSetWorldMatrix;
tdSetViewMatrix_Proc tdSetViewMatrix;
tdSetProjectionMatrix_Proc tdSetProjectionMatrix;
tdLoadTex_Proc tdLoadTex;

tdLoadNormal_Proc tdLoadNormal;
tdSetTexture_Proc tdSetTexture;
tdForceTex_Proc tdForceTex;
tdCreateTex_Proc tdCreateTex;
tdCreateRGTex_Proc tdCreateRGTex;
tdCreateVolRGTex_Proc tdCreateVolRGTex;
tdSetRenderTex_Proc tdSetRenderTex;
tdPrepCubeTex_Proc tdPrepCubeTex;



tdShadeMode_Proc tdShadeMode;
tdLoadTS_Proc tdLoadTS;
tdLoadVS_Proc tdLoadVS;
tdLoadPS_Proc tdLoadPS;
tdSetShader_Proc tdSetShader;
tdSetMat_Proc tdSetMat;
tdSetFloats_Proc tdSetFloats;
tdFillTex_Proc tdFillTex;

tdDrawTex_Proc tdDrawTex;
tdDrawTexPos_Proc tdDrawTexPos;
tdDrawFontVL_Proc tdDrawFontVL;
tdSetBlendMode_Proc tdSetBlendMode;
tdKeyIn_Proc tdKeyIn;
tdGetJoy_Proc tdGetJoy;
tdGetMousePos_Proc tdGetMousePos;
tdLoadAudio_Proc tdLoadAudio;
tdPlayAudio_Proc tdPlayAudio;
tdStopAudio_Proc tdStopAudio;
tdSetAudioVolume_Proc tdSetAudioVolume;
tdIsPlayingAudio_Proc tdIsPlayingAudio;
tdGetFPS_Proc tdGetFPS;
tdCreateAttachedCap_Proc tdCreateAttachedCap;
tdUpdateAttachedCap_Proc tdUpdateAttachedCap;
tdGetAttachedCap_Proc tdGetAttachedCap;
tdDrawCapsule_Proc tdDrawCapsule;
tdCreateOct_Proc tdCreateOct;
tdIntersectOct_Proc tdIntersectOct;


// O[oDLLnh
HINSTANCE g_hLib;

// dll
#define TDGL_LIB		"tdgl.dll"

// ֐݃`FbN
#define CHECK_FUNC( fn ) {if(!fn){MessageBox(NULL,"function not found",#fn,MB_OK);\
return false;}}

// DLLAvP[Vɐڑ܂B
// ́ACû֐̎dlɐ旧čs˂΂Ȃ܂B
extern bool AttachLib( void )
{
	char mtd[0x100];

	g_hLib = LoadLibrary( TDGL_LIB );
	if ( !g_hLib )
	{
		sprintf( mtd, "%s ܂B", TDGL_LIB );
		MessageBox( NULL, mtd, NULL, MB_OK );
		return false;
	}

	tdMemAlloc = (tdMemAlloc_Proc)GetProcAddress( g_hLib, "tdMemAlloc" );
	CHECK_FUNC(tdMemAlloc);
	tdInitLibrary = (tdInitLibrary_Proc)GetProcAddress( g_hLib, "tdInitLibrary" );
	CHECK_FUNC(tdInitLibrary);
	tdEndLibrary = (tdEndLibrary_Proc)GetProcAddress( g_hLib, "tdEndLibrary" );
	CHECK_FUNC(tdEndLibrary);
	tdGetWndSize = (tdGetWndSize_Proc)GetProcAddress( g_hLib, "tdGetWndSize" );
	CHECK_FUNC(tdGetWndSize);
	tdRun = (tdRun_Proc)GetProcAddress( g_hLib, "tdRun" );
	CHECK_FUNC(tdRun);
	tdCls = (tdCls_Proc)GetProcAddress( g_hLib, "tdCls" );
	CHECK_FUNC(tdCls);
	tdFlip = (tdFlip_Proc)GetProcAddress( g_hLib, "tdFlip" );
	CHECK_FUNC(tdFlip);
	tdLoadModel = (tdLoadModel_Proc)GetProcAddress( g_hLib, "tdLoadModel" );
	CHECK_FUNC(tdLoadModel);
	tdLoadAnime = (tdLoadAnime_Proc)GetProcAddress( g_hLib, "tdLoadAnime" );
	CHECK_FUNC(tdLoadAnime);
	tdBindAnime = (tdBindAnime_Proc)GetProcAddress( g_hLib, "tdBindAnime" );
	CHECK_FUNC(tdBindAnime);
	tdSetFreeze = (tdSetFreeze_Proc)GetProcAddress( g_hLib, "tdSetFreeze" );
	CHECK_FUNC(tdSetFreeze);
	tdTransModel = (tdTransModel_Proc)GetProcAddress( g_hLib, "tdTransModel" );
	CHECK_FUNC(tdTransModel);
	tdRenderModel = (tdRenderModel_Proc)GetProcAddress( g_hLib, "tdRenderModel" );
	CHECK_FUNC(tdRenderModel);
	tdShadowMap = (tdShadowMap_Proc)GetProcAddress( g_hLib, "tdShadowMap" );
	CHECK_FUNC(tdShadowMap);
	tdTransMorph = (tdTransMorph_Proc)GetProcAddress( g_hLib, "tdTransMorph" );
	CHECK_FUNC(tdTransMorph);
	tdGetMaxAnime = (tdGetMaxAnime_Proc)GetProcAddress( g_hLib, "tdGetMaxAnime" );
	CHECK_FUNC(tdGetMaxAnime);
	tdGetModelCenter = (tdGetModelCenter_Proc)GetProcAddress( g_hLib, "tdGetModelCenter" );
	CHECK_FUNC(tdGetModelCenter);
	tdGetModelRadius = (tdGetModelRadius_Proc)GetProcAddress( g_hLib, "tdGetModelRadius" );
	CHECK_FUNC(tdGetModelRadius);


	tdSetWorldMatrix = (tdSetWorldMatrix_Proc)GetProcAddress( g_hLib, "tdSetWorldMatrix" );
	CHECK_FUNC(tdSetWorldMatrix);
	tdSetViewMatrix = (tdSetViewMatrix_Proc)GetProcAddress( g_hLib, "tdSetViewMatrix" );
	CHECK_FUNC(tdSetViewMatrix);
	tdSetProjectionMatrix = (tdSetProjectionMatrix_Proc)GetProcAddress( g_hLib, "tdSetProjectionMatrix" );
	CHECK_FUNC(tdSetProjectionMatrix);
	tdLoadTex = (tdLoadTex_Proc)GetProcAddress( g_hLib, "tdLoadTex" );
	CHECK_FUNC(tdLoadTex);

	tdLoadNormal = (tdLoadNormal_Proc)GetProcAddress( g_hLib, "tdLoadNormal" );
	CHECK_FUNC(tdLoadNormal);
	tdSetTexture = (tdSetTexture_Proc)GetProcAddress( g_hLib, "tdSetTexture" );
	CHECK_FUNC(tdSetTexture);
	tdForceTex = (tdForceTex_Proc)GetProcAddress( g_hLib, "tdForceTex" );
	CHECK_FUNC(tdForceTex);
	tdCreateTex = (tdCreateTex_Proc)GetProcAddress( g_hLib, "tdCreateTex" );
	CHECK_FUNC(tdCreateTex);
	tdCreateRGTex = (tdCreateRGTex_Proc)GetProcAddress( g_hLib, "tdCreateRGTex" );
	CHECK_FUNC(tdCreateRGTex);
	tdCreateVolRGTex = (tdCreateVolRGTex_Proc)GetProcAddress( g_hLib, "tdCreateVolRGTex" );
	CHECK_FUNC(tdCreateVolRGTex);
	tdSetRenderTex = (tdSetRenderTex_Proc)GetProcAddress( g_hLib, "tdSetRenderTex" );
	CHECK_FUNC(tdSetRenderTex);
	tdPrepCubeTex = (tdPrepCubeTex_Proc)GetProcAddress( g_hLib, "tdPrepCubeTex" );
	CHECK_FUNC(tdPrepCubeTex);

	tdShadeMode = (tdShadeMode_Proc)GetProcAddress( g_hLib, "tdShadeMode" );
	CHECK_FUNC(tdShadeMode);
	tdLoadTS = (tdLoadTS_Proc)GetProcAddress( g_hLib, "tdLoadTS" );
	CHECK_FUNC(tdLoadTS);
	tdLoadVS = (tdLoadVS_Proc)GetProcAddress( g_hLib, "tdLoadVS" );
	CHECK_FUNC(tdLoadVS);
	tdLoadPS = (tdLoadPS_Proc)GetProcAddress( g_hLib, "tdLoadPS" );
	CHECK_FUNC(tdLoadPS);
	tdSetShader = (tdSetShader_Proc)GetProcAddress( g_hLib, "tdSetShader" );
	CHECK_FUNC(tdSetShader);
	tdSetMat = (tdSetMat_Proc)GetProcAddress( g_hLib, "tdSetMat" );
	CHECK_FUNC(tdSetMat);
	tdSetFloats = (tdSetFloats_Proc)GetProcAddress( g_hLib, "tdSetFloats" );
	CHECK_FUNC(tdSetFloats);
	tdFillTex = (tdFillTex_Proc)GetProcAddress( g_hLib, "tdFillTex" );
	CHECK_FUNC(tdFillTex);

	tdDrawTex = (tdDrawTex_Proc)GetProcAddress( g_hLib, "tdDrawTex" );
	CHECK_FUNC(tdDrawTex);
	tdDrawTexPos = (tdDrawTexPos_Proc)GetProcAddress( g_hLib, "tdDrawTexPos" );
	CHECK_FUNC(tdDrawTex);
	tdDrawFontVL = (tdDrawFontVL_Proc)GetProcAddress( g_hLib, "tdDrawFontVL" );
	CHECK_FUNC(tdDrawFontVL);
	tdSetBlendMode = (tdSetBlendMode_Proc)GetProcAddress( g_hLib, "tdSetBlendMode" );
	CHECK_FUNC(tdSetBlendMode);
	tdKeyIn = (tdKeyIn_Proc)GetProcAddress( g_hLib, "tdKeyIn" );
	CHECK_FUNC(tdKeyIn);
	tdGetJoy = (tdGetJoy_Proc)GetProcAddress( g_hLib, "tdGetJoy" );
	CHECK_FUNC(tdGetJoy);
	tdGetMousePos = (tdGetMousePos_Proc)GetProcAddress( g_hLib, "tdGetMousePos" );
	CHECK_FUNC(tdGetMousePos);
	tdLoadAudio = (tdLoadAudio_Proc)GetProcAddress( g_hLib, "tdLoadAudio" );
	CHECK_FUNC(tdLoadAudio);
	tdPlayAudio = (tdPlayAudio_Proc)GetProcAddress( g_hLib, "tdPlayAudio" );
	CHECK_FUNC(tdPlayAudio);
	tdStopAudio = (tdStopAudio_Proc)GetProcAddress( g_hLib, "tdStopAudio" );
	CHECK_FUNC(tdStopAudio);
	tdSetAudioVolume = (tdSetAudioVolume_Proc)GetProcAddress( g_hLib, "tdSetAudioVolume" );
	CHECK_FUNC(tdSetAudioVolume);
	tdIsPlayingAudio = (tdIsPlayingAudio_Proc)GetProcAddress( g_hLib, "tdIsPlayingAudio" );
	CHECK_FUNC(tdIsPlayingAudio);
	tdGetFPS = (tdGetFPS_Proc)GetProcAddress( g_hLib, "tdGetFPS" );
	CHECK_FUNC(tdGetFPS);
	tdCreateAttachedCap = (tdCreateAttachedCap_Proc)GetProcAddress( g_hLib, "tdCreateAttachedCap" );
	CHECK_FUNC(tdCreateAttachedCap);
	tdUpdateAttachedCap = (tdUpdateAttachedCap_Proc)GetProcAddress( g_hLib, "tdUpdateAttachedCap" );
	CHECK_FUNC(tdUpdateAttachedCap);
	tdGetAttachedCap = (tdGetAttachedCap_Proc)GetProcAddress( g_hLib, "tdGetAttachedCap" );
	CHECK_FUNC(tdGetAttachedCap);
	tdDrawCapsule = (tdDrawCapsule_Proc)GetProcAddress( g_hLib, "tdDrawCapsule" );
	CHECK_FUNC(tdDrawCapsule);
	tdCreateOct = (tdCreateOct_Proc)GetProcAddress( g_hLib, "tdCreateOct" );
	CHECK_FUNC(tdCreateOct);
	tdIntersectOct = (tdIntersectOct_Proc)GetProcAddress( g_hLib, "tdIntersectOct" );
	CHECK_FUNC(tdIntersectOct);

	return true;
}

// DLL؂藣܂B
// ̌ɁACů֐ĂяoƂ͏o܂B
extern void DetachLib( void )
{
	FreeLibrary( g_hLib );
}

// CuŎɎgp郁蓖Ă܂B
// łAfނǂݍ߂ȂȂ\܂B
// InitLibrary֐ɁAĂяoKv܂B
// FMemAlloc( 0x100000 * 16, 1 ); // 16MB1y[Wmۂ
extern void MemAlloc( int nByte, int nPage )
{
	tdMemAlloc( nByte, nPage );
}

extern bool InitLibrary( bool bFullScreen, int *pnCtrl, HINSTANCE hInst )
{
	if ( !AttachLib() )
		return false;
	MemAlloc( MEMORY_TO_ALLOC, 1 );
	if ( hInst == NULL )
		hInst	= g_hLib;
	return tdInitLibrary( bFullScreen, pnCtrl, hInst );
}

extern void EndLibrary( void )
{
	tdEndLibrary();
	DetachLib();
}

extern void GetWndSize( int *pWidth, int *pHeight )
{
	tdGetWndSize( pWidth, pHeight );
}

extern bool Run( void )
{
	return tdRun();
}

extern void Cls( DWORD color )
{
	tdCls(color);
}

extern void Flip( void )
{
	tdFlip();
}

extern int LoadModel( char *fileName )
{
	return tdLoadModel( fileName );
}

extern int LoadAnime( char *fileName )
{
	return tdLoadAnime( fileName );
}

extern bool BindAnime( int hModel, int hAnime, int nAnimeNo )
{
	return tdBindAnime( hModel, hAnime, nAnimeNo );
}

extern void SetFreeze( int hModel, bool bValid )
{
	tdSetFreeze( hModel, bValid );
}

extern void TransModel( int hModel, MATRIX *pMat, 
						int nAnimeNo, float keyFrame, int nInterpolate,
						int nMorphNo )
{
	tdTransModel( hModel, pMat, nAnimeNo, keyFrame, nInterpolate, nMorphNo );
}

extern void RenderModel( int hModel )
{
	tdRenderModel( hModel );
}

extern void ShadowMap( VECTOR *vLightPos, int hFromModel, int hToModel, CAMERA *pCamera, BYTE Alpha )
{
	tdShadowMap( vLightPos, hFromModel, hToModel, pCamera, Alpha );
}

extern void TransMorph( int hModel0, int nNo0, int hModel1, int nNo1, float param )
{
	tdTransMorph( hModel0, nNo0, hModel1, nNo1, param );
}

extern int GetMaxAnime( int hAnime )
{
	return tdGetMaxAnime( hAnime );
}

extern VECTOR GetModelCenter( int hModel )
{
	return tdGetModelCenter( hModel );
}

extern float GetModelRadius( int hModel )
{
	return tdGetModelRadius( hModel );
}




extern void SetWorldMatrix( MATRIX *pMat )
{
	tdSetWorldMatrix( pMat );
}

extern void SetViewMatrix( MATRIX *pMat )
{
	tdSetViewMatrix( pMat );
}

extern void SetProjectionMatrix( MATRIX *pMat )
{
	tdSetProjectionMatrix( pMat );
}

extern int LoadTex( char *fileName )
{
	return tdLoadTex( fileName );
}


extern int LoadNormal( char *fileName )
{
	return tdLoadNormal( fileName );
}

extern void SetTexture( DWORD dwStage, int hTex )
{
	tdSetTexture( dwStage, hTex );
}

extern void ForceTex( DWORD dwStage, int hTex, bool bForce )
{
	tdForceTex( dwStage, hTex, bForce );
}

extern int CreateTex( int width, int height, bool bRender )
{
	return tdCreateTex( width, height, bRender );
}

extern int CreateRGTex( int width, int height, bool bRender )
{
	return tdCreateRGTex( width, height, bRender );
}

extern int CreateVolRGTex( int width, int height, int depth )
{
	return tdCreateVolRGTex( width, height, depth );
}

extern void SetRenderTex( int hTex )
{
	tdSetRenderTex( hTex );
}

extern void PrepCubeTex( int hTex, int no, VECTOR *vPos )
{
	tdPrepCubeTex( hTex, no, vPos );
}





extern void ShadeMode( int nMode )
{
	tdShadeMode( nMode );
}

extern int LoadTS( char *fileName, char *funcName )
{
	return tdLoadTS( fileName, funcName );
}

extern int LoadVS( char *fileName, char *funcName )
{
	return tdLoadVS( fileName, funcName );
}

extern int LoadPS( char *fileName, char *funcName )
{
	return tdLoadPS( fileName, funcName );
}

extern void SetShader( int hShader )
{
	tdSetShader( hShader );
}

extern void SetMat( int hShader, char *name, MATRIX *mat )
{
	tdSetMat( hShader, name, mat );
}

extern void SetFloats( int hShader, char *name, float *values, int num )
{
	tdSetFloats( hShader, name, values, num );
}

extern bool FillTex( int hTex, int hShader )
{
	return tdFillTex( hTex, hShader );
}



extern void DrawTex( int hTex )
{
	tdDrawTex( hTex );
}

extern void DrawTexPos( int hTex, int x, int y )
{
	tdDrawTexPos( hTex, x, y );
}

extern void DrawFont( int x, int y, DWORD color, const char *format, ... )
{
	va_list vl;

	va_start( vl, format );
	tdDrawFontVL( x, y, color, format, vl );
	va_end( vl );
}

extern void SetBlendMode( int nMode, int nValue )
{
	tdSetBlendMode( nMode, nValue );
}

extern int KeyIn( int nMode )
{
	return tdKeyIn( nMode );
}

extern int GetJoy( int nCtrlNo )
{
	return tdGetJoy( nCtrlNo );
}

extern void GetMousePos( int *x, int *y )
{
	tdGetMousePos( x, y );
}

extern int LoadAudio( char *fileName )
{
	return tdLoadAudio( fileName );
}

extern void PlayAudio( int hAudio )
{
	tdPlayAudio( hAudio );
}

extern void StopAudio( int hAudio )
{
	tdStopAudio( hAudio );
}

extern void SetAudioVolume( int hAudio, float fVolume )
{
	tdSetAudioVolume( hAudio, fVolume );
}

extern bool IsPlayingAudio( int hAudio )
{
	return tdIsPlayingAudio( hAudio );
}

extern int GetFPS( void )
{
	return tdGetFPS();
}

extern int CreateOct( int hModel, float fRate )
{
	return tdCreateOct( hModel, fRate );
}

extern bool IntersectOct( int hOct, VECTOR *pV0, VECTOR *pV1, VECTOR *pVintersect )
{
	return tdIntersectOct( hOct, pV0, pV1, pVintersect );
}

extern int CreateAttachedCap( VECTOR *pV0, VECTOR *pV1, float fRadius,
						int hModel, char *szFrameName )
{
	return tdCreateAttachedCap( pV0, pV1, fRadius, hModel, szFrameName );
}

extern void UpdateAttachedCap( int hCap )
{
	tdUpdateAttachedCap( hCap );
}

extern CAPSULE* GetAttachedCap( int hCap )
{
	return tdGetAttachedCap( hCap );
}

extern void DrawCapsule( CAPSULE *pCapsule, int nColor )
{
	tdDrawCapsule( pCapsule, nColor );
}